<?php
/**
*
* @author Stoker 4.0
* @package PhpBB Links Mod
* @version $Id: acp_linksmod_config.php, v1.0.3 Stoker 4.0 Exp $
* @copyright (c) 2013 Stoker 4.0 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_linksmod_config
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/linksmod');
		$this->tpl_name = 'acp_linksmod_config';
		$this->page_title = $user->lang['LINKSMOD_CONFIG'];
		add_form_key('acp_linksmod_config');
		
		$submit = (isset($_POST['submit'])) ? true : false;
		if ($submit)
		{
			if (!check_form_key('acp_linksmod_config'))
			{
				trigger_error('FORM_INVALID');
			}
			set_config('linksmod_enable', request_var('linksmod_enable', 0));
			set_config('linksclick_enable', request_var('linksclick_enable', 0));
			set_config('linksthumb_enable', request_var('linksthumb_enable', 0));
			set_config('linksbanner_enable', request_var('linksbanner_enable', 0));
			set_config('linkspage_number', request_var('linkspage_number', 25));
			set_config('linksmod_stw', request_var('linksmod_stw', ''));

			trigger_error($user->lang['LINKSMOD_CONFIG_SAVED'] . adm_back_link($this->u_action));
		}
		$template->assign_vars(array(
			'LINKSMOD_VERSION'			=> (isset($config['linksmod_version'])) ? $config['linksmod_version'] : '',
			'LINKSMOD_ENABLE'			=> (!empty($config['linksmod_enable'])) ? true : false,
			'LINKSCLICK_ENABLE'			=> (!empty($config['linksclick_enable'])) ? true : false,
			'LINKSTHUMB_ENABLE'			=> (!empty($config['linksthumb_enable'])) ? true : false,
			'LINKSBANNER_ENABLE'		=> (!empty($config['linksbanner_enable'])) ? true : false,
			'LINKSPAGE_NUMBER'			=> (isset($config['linkspage_number'])) ? $config['linkspage_number'] : '',
			'LINKSMOD_STW'				=> $config['linksmod_stw'],
			'U_ACTION'					=> $this->u_action,
		));
	}
}

?>