<?php
/** 
*
* @author Stoker 4.0
* @package PhpBB Links Mod
* @version $Id: acp_linksmod.php, v1.0.3 Exp $
* @copyright (c) 2013 Stoker 4.0 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
	
/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}
		
/**
* @package acp
*/
class acp_linksmod_links
{
	var $u_action;
					
	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
					
		$user->add_lang(array('acp/posting', 'mods/linksmod'));

		// Set up general vars
		$action 		= request_var('action', '');
		$action 		= (isset($_POST['add'])) ? 'add' : $action;
		$action 		= (isset($_POST['save'])) ? 'save' : $action;
		$linksmod_id 	= request_var('id', 0);
		$start 			= request_var('start', 0);
							
		// Set up the page
		$this->tpl_name 	= 'acp_linksmod';
		$this->page_title 	= 'ACP_LINKSMOD';

		add_form_key('acp_linksmod');

		switch ($action)
		{
			case 'save':

				if (!check_form_key('acp_linksmod'))
				{
					trigger_error ($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
				}
				$linksmod_name = utf8_normalize_nfc(request_var('name', '', true));
				$linksmod_url = utf8_normalize_nfc(request_var('url', '', true));
				$linksmod_desc = utf8_normalize_nfc(request_var('desc', '', true));
				$linksmod_banner = utf8_normalize_nfc(request_var('banner', '', true));
				
				$uid = $bitfield = $options = ''; 
				$allow_bbcode = $allow_urls = $allow_smilies = true;
				generate_text_for_storage($linksmod_desc, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
				
				// We can't have a link without a name ;)
				if (!$linksmod_name)
				{
					trigger_error($user->lang['NO_LINKSMOD_NAME'] . adm_back_link($this->u_action . '&amp;action=add'), E_USER_WARNING);
				}

				// Same goes for the URL
				if (!$linksmod_url)
				{
					trigger_error($user->lang['NO_LINKSMOD_URL'] . adm_back_link($this->u_action . '&amp;action=add'), E_USER_WARNING);
				}

				$sql_ary = array(
					'linksmod_name'					=> $linksmod_name,
					'linksmod_url'					=> $linksmod_url,
					'linksmod_desc'					=> $linksmod_desc,
					'linksmod_banner'				=> $linksmod_banner,
					'linksmod_bbcode_uid'			=> $uid,
					'linksmod_bbcode_bitfield'		=> $bitfield,
					'linksmod_bbcode_options'		=> $options,
				);
				
				if ($linksmod_id)
				{
					$sql = 'UPDATE ' . LINKS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE linksmod_id = $linksmod_id";
					$message = $user->lang['LINKSMOD_UPDATED'];

					add_log('admin', 'LOG_LINKSMOD_UPDATED', $linksmod_name);
				}
				else
				{
					// stolen from Custom BBCode Sorting
					// Get new order...
					$sql = 'SELECT MAX(order_id) as max_order_id
						FROM ' . LINKS_TABLE;
					$result = $db->sql_query($sql);
					$max_order = (int) $db->sql_fetchfield('max_order_id');
					$db->sql_freeresult($result);
					$sql_ary['order_id'] = $max_order + 1;
					// stolen from Custom BBCode Sorting	
 
					$sql = 'INSERT INTO ' . LINKS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$message = $user->lang['LINKSMOD_ADDED'];

					add_log('admin', 'LOG_LINKSMOD_ADDED', $linksmod_name);
					set_config('linkshits_mod', ($config['linkshits_mod'] + 1), true); 
				}
				$db->sql_query($sql);

				$cache->destroy('_linksmod');

				trigger_error($message . adm_back_link($this->u_action));

			break;

			case 'delete':

				if (!$linksmod_id)
				{
					trigger_error($user->lang['MUST_SELECT_LINK'] . adm_back_link($this->u_action), E_USER_WARNING);
				}

				if (confirm_box(true))
				{
					$sql = 'SELECT linksmod_name
						FROM ' . LINKS_TABLE . '
						WHERE linksmod_id = ' . $linksmod_id;
					$result = $db->sql_query($sql);
					$linksib_name = (string) $db->sql_fetchfield('linksmod_name');
					$db->sql_freeresult($result);

					$sql = 'DELETE FROM ' . LINKS_TABLE . "
						WHERE linksmod_id = $linksmod_id";
					$db->sql_query($sql);

					$cache->destroy('_linksmod');

					add_log('admin', 'LOG_LINKSMOD_REMOVED', $linksmod_id);
					set_config('linkshits_mod', ($config['linkshits_mod'] - 1), true); 
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
						'i'		=> $id,
						'mode'		=> $mode,
						'linksmod_id'	=> $linksmod_id,
						'action'		=> 'delete',
					)));
				}

			break;
			
			// stolen from Custom BBCode Sorting				
			case 'move_up':
			case 'move_down':

				$order = request_var('order', 0);
				$order_total = $order * 2 + (($action == 'move_up') ? -1 : 1);

				$sql = 'UPDATE ' . LINKS_TABLE . '
					SET order_id = ' . $order_total . ' - order_id
					WHERE order_id IN (' . $order . ', ' . (($action == 'move_up') ? $order - 1 : $order + 1) . ')';
				$db->sql_query($sql);

			break;
			
			// END stolen Custom BBCode Sorting	
			case 'edit':
			case 'add':
				
				$sql = 'SELECT *
					FROM ' . LINKS_TABLE . '
					ORDER BY linksmod_id ASC';
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					decode_message($row['linksmod_desc'], $row['linksmod_bbcode_uid']);
					if ($action == 'edit' && $linksmod_id == $row['linksmod_id'])
					{
						$linksmod = $row;
					}
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'S_EDIT'			=> true,
					'U_BACK'			=> $this->u_action,
					'U_ACTION'			=> $this->u_action . '&amp;id=' . $linksmod_id,

					'LINKSMOD_NAME'		=> (isset($linksmod['linksmod_name'])) ? $linksmod['linksmod_name'] : '',
					'LINKSMOD_URL'		=> (isset($linksmod['linksmod_url'])) ? $linksmod['linksmod_url'] : '',
					'LINKSMOD_DESC'		=> (isset($linksmod['linksmod_desc'])) ? $linksmod['linksmod_desc'] : '',
					'LINKSMOD_BANNER'	=> (isset($linksmod['linksmod_banner'])) ? $linksmod['linksmod_banner'] : '',
				));	

				return;

			break;
		}
		// END Custom BBCode Sorting
		
		// How many Links do we have?
		$sql = 'SELECT COUNT(linksmod_id) AS total_links
			FROM ' .LINKS_TABLE . '
			ORDER BY linksmod_id';
		$result = $db->sql_query($sql);
		$total_links = (int) $db->sql_fetchfield('total_links');
		$db->sql_freeresult($result);		

		//Pull Links from the database
		$sql = 'SELECT *
			FROM ' . LINKS_TABLE . '
			ORDER BY order_id ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$linksmod_desc = generate_text_for_display($row['linksmod_desc'], $row['linksmod_bbcode_uid'], $row['linksmod_bbcode_bitfield'], $row['linksmod_bbcode_options']);
			
			$template->assign_block_vars('linksmod', array(
				'LINKSMOD_ID'		=> $row['linksmod_id'],
				'LINKSMOD_NAME'		=> $row['linksmod_name'],
				'LINKSMOD_URL'		=> $row['linksmod_url'],
				'LINKSMOD_DESC'		=> $linksmod_desc,
				'LINKSMOD_BANNER'	=> $row['linksmod_banner'],
				'LINKSMOD_CLICK'  	=> $row['linksmod_click'],
				'U_MOVE_UP'			=> $this->u_action . '&amp;action=move_up&amp;order=' . $row['order_id'],
				'U_MOVE_DOWN'		=> $this->u_action . '&amp;action=move_down&amp;order=' . $row['order_id'],	
				'U_EDIT'			=> $this->u_action . '&amp;action=edit&amp;id=' . $row['linksmod_id'],
				'U_DELETE'			=> $this->u_action . '&amp;action=delete&amp;id=' . $row['linksmod_id'])
			);	
		}
		$db->sql_freeresult($result);
		
		// BEGIN Custom BBCode Sorting		
		// By default, check that order is valid and fix it if necessary
		$sql = 'SELECT linksmod_id, order_id
			FROM ' . LINKS_TABLE  . '
			ORDER BY order_id';
		$result = $db->sql_query($sql);

		if ($row = $db->sql_fetchrow($result))
		{
			$order = 0;
			do
			{
				++$order;
				
				if ($row['order_id'] != $order)
				{
					$sql = 'UPDATE ' . LINKS_TABLE  . "
						SET order_id = $order
						WHERE linksmod_id = {$row['linksmod_id']}";
					$db->sql_query($sql);
				}
			}
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);
		// END Custom BBCode Sorting
		
		$template->assign_vars(array( 
			'COUNTED_LINKS'    	=> ($total_links == 1) ? $user->lang['LINK_COUNT'] : sprintf($user->lang['LINKS_COUNT'], $total_links),
			'U_ACTION'			=> $this->u_action)
		);
	}
}

?>