<?php
/**
*
* @author Stoker 4.0
* @package PhpBB Links Mod
* @version $Id: install_linksmod.php, v1.0.3 Exp $
* @copyright (c) 2013 Stoker 4.0 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

$mod_name = 'LINKSMOD';

$version_config_name = 'linksmod_version';
$language_file = 'mods/linksmod';

$versions = array(

	'1.0.0'	=> array(
		'config_add' => array(
			array('linksmod_enable', 0),
			array('linksclick_enable', 0),
			array('linksthumb_enable', 0),
			array('linkspage_number', 25),
		),
		
		// Add the table for link pages text
		'table_add' => array(
			array('phpbb_links', array(
					'COLUMNS'		=> array(
						'linksmod_id'		=> array('UINT', NULL, 'auto_increment'),
						'linksmod_name'		=> array('VCHAR:255', ''),
						'linksmod_url'		=> array('VCHAR:255', ''),
						'linksmod_desc'		=> array('TEXT', ''),
						'linksmod_click'	=> array('UINT', 0),
						'linksmod_banner'	=> array('VCHAR:255', ''),
					),
					'PRIMARY_KEY'	=> 'linksmod_id',
				),
			),
		),		
		
		// Add the module in ACP under the mods tab
		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_LINKSMOD'),
			
			array('acp', 'ACP_LINKSMOD', array(
					'module_basename'	=> 'linksmod_config',
					'module_langname'	=> 'LINKSMOD_CONFIG',
					'module_mode'		=> 'overview',
					'module_auth'		=> 'acl_a_board',
				),
			),
			array('acp', 'ACP_LINKSMOD', array(
					'module_basename'	=> 'linksmod_links',
					'module_langname'	=> 'LINKSMOD_LINKS',
					'module_mode'		=> 'overview',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),
	),
	// Version 1.0.1
	'1.0.1'	=> array(
		'config_add' => array(
			array('linksbanner_enable', 0),
		),
	),
	// Version 1.0.2
	'1.0.2'	=> array(
		'table_column_add' => array(
            array('phpbb_links', 'order_id', array('USINT', 0)), 	
		),
	),
	// Version 1.0.3
	'1.0.3'	=> array(
		'table_column_add' => array(
			array('phpbb_links','linksmod_bbcode_uid', array('VCHAR:8', '')),
			array('phpbb_links','linksmod_bbcode_bitfield', array('VCHAR:255', '')),
			array('phpbb_links','linksmod_bbcode_options', array('UINT:11', 7)),
		),
		'config_add' => array(
			array('linkshits_mod', 0),
			array('linkshits_stw', ''),
		),
		// purge the cache
		'cache_purge' => array(''),
	),
	
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>