<?php
/** 
*
* @author Stoker 4.0
* @package PhpBB Links Mod
* @version $Id: links.php,v 1.0.3 Exp $
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/linksmod');
$start = request_var('start', 0);

// Do we have the Links mod enabled
if (isset($config['linksmod_enable']) && $config['linksmod_enable'] == 0)
{
	trigger_error($user->lang['LINKSMOD_DISABLED'], E_USER_NOTICE);
}

// Is the Links mod installed
if (empty($config['linksmod_version']))
{
	if($user->data['user_type'] == USER_FOUNDER)
	{
		$installer =  append_sid("{$phpbb_root_path}install_linksmod.$phpEx");
		$message = sprintf($user->lang['LINKSMOD_NOT_INSTALLED'], '<a href="' . $installer . '">', '</a>');
	}
	else
	{
		$message = $user->lang['LINKSMOD_NOT_INSTALLED_USER'];
	}
	trigger_error ($message);
}

// How many Links do we have?
$sql = 'SELECT COUNT(linksmod_id) AS total_links
	FROM ' .LINKS_TABLE . '
	ORDER BY linksmod_id';

$result = $db->sql_query($sql);
$total_links = (int) $db->sql_fetchfield('total_links');
$db->sql_freeresult($result);

// Do we have any links in the table
if ($total_links < 1)
{
	trigger_error($user->lang['LINKSMOD_EMPTY'], E_USER_NOTICE);
}

$pagination_url = append_sid("{$phpbb_root_path}links.$phpEx");

//Pull Links from the database
$sql = 'SELECT *
	FROM ' . LINKS_TABLE . '
	ORDER BY order_id ASC';
$result = $db->sql_query_limit($sql, $config['linkspage_number'], $start);

while ($row = $db->sql_fetchrow($result))
{
	$linksmod_desc = generate_text_for_display($row['linksmod_desc'], $row['linksmod_bbcode_uid'], $row['linksmod_bbcode_bitfield'], $row['linksmod_bbcode_options']);
	
	$template->assign_block_vars('linksmod', array(
		'LINKSMOD_ID'		=> $row['linksmod_id'],
		'LINKSMOD_NAME'		=> $row['linksmod_name'],
		'LINKSMOD_URL'		=> $row['linksmod_url'],
		'LINKSMOD_DESC'		=> $linksmod_desc,
		'LINKSMOD_BANNER'	=> $row['linksmod_banner'],
		'LINKSMOD_CLICK'  	=> $row['linksmod_click'],
	));	
}
$db->sql_freeresult($result);

$template->assign_vars(array(
        'PAGINATION'        => generate_pagination($pagination_url, $total_links, $config['linkspage_number'], $start),
        'PAGE_NUMBER'       => on_page($total_links, $config['linkspage_number'], $start),
        'TOTAL_LINKS'		=> ($total_links == 1) ? $user->lang['LINK_COUNT'] : sprintf($user->lang['LINKS_COUNT'], $total_links),
		'LINKSMOD_STW'  	=> $config['linksmod_stw'],
    ));
	
// Set up Navlinks
$template->assign_block_vars('navlinks', array(
'FORUM_NAME' => ($user->lang['LINKS']),
'U_VIEW_FORUM' => append_sid("{$phpbb_root_path}links.$phpEx"))
);

page_header($user->lang['LINKSMODPAGE_TITLE'] . ($start ? ' - ' . sprintf($user->lang['LINKS_TITLE_PAGE_NUMBER'], floor($start / $config['linkspage_number']) + 1) : ''), false);

$template->set_filenames(array(
	'body' => 'linksmod_body.html'
));

page_footer();

?>